import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import {
  FinishedwarehouseListItem,
  FinishedwarehousePageListGetResultModel,
  FinishedwarehousePageParams,

  FinishedwarehouseDetailPageParams,
  FinishedwarehouseDetailPageListGetResultModel,
  FinishedwarehouseDetailSNPageParams,
  FinishedwarehousePageDetailSNListGetResultModel


} from '../model/warehoueseModel';
import { genAction, Api, genActionPage } from '../system';
import { useUserStore } from '/@/store/modules/user';
import { defHttp } from '/@/utils/http/axios';
import { isNullOrEmpty } from '/@/utils/is';

/*
 * 获取完工入库单分页列表
 */

export const getFinishedwarehouseListByPage = async (params: FinishedwarehousePageParams) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.BILLCODE != undefined && params?.BILLCODE != '') {
    sqlcmd += " And BILLCODE like '%" + params?.BILLCODE + "%'";
  }
  if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
    sqlcmd += " And BILLDATE > '" + params?.BILLDATE[0] + "'";
  }
  if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
    sqlcmd += " And BILLDATE < '" + params?.BILLDATE[1] + "'";
  }
  if (!isNullOrEmpty(params?.STATUS)) {
    sqlcmd += " And STATUS = '" + params?.STATUS + "'";
  }

  let option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  if (!isNullOrEmpty(params.page)) {
    const usParams = genAction('BIZ_ERP_PROD_IN', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      },
      option
    },option);
    return getFinishedwarehouseListByPageAsync(usParams);
  } else {
    const usParams = genAction('BIZ_ERP_PROD_IN', {
      QueryAble_T: '',
      where: sqlcmd,
      option
    },option);
    return getFinishedwarehouseListByPageAsync(usParams);
  }
  // const rParams = genActionPage('BIZ_ERP_PROD_IN', sqlcmd, params.page, params.pageSize,option);
  // return getFinishedwarehouseListByPageAsync(rParams);
};
async function getFinishedwarehouseListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  const model = {
    items: data.Data.page.data,
    total: data.Data.page.totals,
  };
  return model;
}
// 单据详情
export const getFinishedwarehouseDetailListByPage = async (
  params: FinishedwarehouseDetailPageParams,
) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.BILLCODE != undefined && params?.BILLCODE != '') {
    sqlcmd += " And BILLCODE = '" + params?.BILLCODE + "'";
  }
  if (params?.ITEM_CODE != undefined && params?.ITEM_CODE != '') {
    sqlcmd += " And ITEM_CODE = '" + params?.ITEM_CODE + "'";
  }
  if (!isNullOrEmpty(params?.LINESTATUS)) {
    sqlcmd += " And LINESTATUS = '" + params?.LINESTATUS + "'";
  }
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  if (!isNullOrEmpty(params.page)) {
    const usParams = genAction('V_BIZ_ERP_PROD_IN_DTL', {
      QueryAble_T: '',
      where: sqlcmd,
      order: 'BILLLINE*1 '+order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      },
      option
    },option);
    return getFinishedwarehouseDetailListByPageAsync(usParams);
  } else {
    const usParams = genAction('V_BIZ_ERP_PROD_IN_DTL', {
      QueryAble_T: '',
      where: sqlcmd,
      order: 'BILLLINE*1',
      option
    },option);
    return getFinishedwarehouseDetailListByPageAsync(usParams);
  }  
};
async function getFinishedwarehouseDetailListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {}
  if (isNullOrEmpty(data.Data.page)) {
    model = {
      items: data.Data.Items,
    };
  } else {
      model = {
        items: data.Data.page.data,
        total: data.Data.page.totals,
      };
    }
    return model;
}
// async function getFinishedwarehouseDetailListByPageAsync(params: ApiActionPage) {
//   const data = await defHttp.post<ApiActionPage>(
//     { url: Api.EntityPageList, params },
//     {
//       isTransformResponse: false,
//     },
//   );
//   const model: FinishedwarehouseDetailPageListGetResultModel = {
//     items: data.Data.data,
//     total: data.Data.totals,
//   };
//   return model;
// }

//条码详情
export const getFinishedwarehouseDetailSNListByPage = async (params: FinishedwarehouseDetailSNPageParams) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.ITEM_CODE != undefined && params?.ITEM_CODE != '') {
    sqlcmd += " And ITEM_CODE = '" + params?.ITEM_CODE + "'";
  }
  if (params?.BILLCODE != undefined && params?.BILLCODE != '') {
    sqlcmd += " And BUSINESSCODE = '" + params?.BILLCODE + "'";
  }
  if (params?.SN != undefined && params?.SN != '') {
    sqlcmd += " And SN = '" + params?.SN + "'";
  }
  // if (!isNullOrEmpty(params?.LINESTATUS)) {
  //   sqlcmd += " And LINESTATUS = '" + params?.LINESTATUS + "'";
  // }
  // if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
  //   sqlcmd += "And BILLDATE like '%" + params?.BILLDATE + "%'";
  // }
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  if (!isNullOrEmpty(params.page)) {
    const usParams = genAction('BIZ_ERP_PROD_IN_SN', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      },
      option
    },option);
    return getFinishedwarehouseDetailSNListByPageAsync(usParams);
  } else {
    const usParams = genAction('BIZ_ERP_PROD_IN_SN', {
      QueryAble_T: '',
      where: sqlcmd,
      option
    },option);
    return getFinishedwarehouseDetailSNListByPageAsync(usParams);
  }  
  // const rParams = genActionPage('BIZ_ERP_PROD_IN_SN', sqlcmd, params.page, params.pageSize,option);
  // return getFinishedwarehouseDetailSNListByPageAsync(rParams);
};
async function getFinishedwarehouseDetailSNListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {}
  if (isNullOrEmpty(data.Data.page)) {
    model = {
      items: data.Data.Items,
    };
  } else {
      model = {
        items: data.Data.page.data,
        total: data.Data.page.totals,
      };
    }
    return model;
}
export const  getStatusRestored = async (params: any) =>{
  let data;
  data = await defHttp.post({
    url:Api.GetStatusRestored,
    params:{WorkOrder:params},
    timeout:10*60*1000
  },
  {
    isTransformResponse: false,
  },
  );
  return data;
}
export const SaveItemAndPkg = async (params: any) => {
  let data;
  data= await defHttp.get(
    { url: Api.MaterialResale, 
      params: {billcode:params.field1,whcode:params.WH_CODE,org_code:params.ORG_CODE},
      timeout:10*60*1000
    },
    {
      isTransformResponse: false,
    },
  );
  
  return data;
};
// export const DeleteEnterWarehouse = async (params: Recordable) => {
//   const usParams = genAction('Minsun.WMS_RECEIPT_H', [params]);
//   return await defHttp.post(
//     { url: Api.DeleteList, params: usParams },
//     {
//       errorMessageMode: 'none',
//       isTransformResponse: false,
//     },
//   );
// };
//下拉列表
// STATUSs 单据状态
export const optionsListApi = async (params: Recordable) => {
  const usParams = genAction('BIZ_ERP_PROD_IN+STATUSs', '');
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
};